VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "PDF Read"
   ClientHeight    =   6165
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5085
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6165
   ScaleWidth      =   5085
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox Text1 
      Height          =   5415
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   600
      Width           =   4815
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Achtung: Der Vorgang wird mglicherweise einige Zeit in Anspruch nehmen."
      Height          =   495
      Left            =   1440
      TabIndex        =   2
      Top             =   120
      Visible         =   0   'False
      Width           =   3495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

' Verweis : Adobe Acrobat 5.0 Type Library
' Link fr SDK : http://partners.adobe.com/asn/developer/sdks.html

' Author: Ruru Date: 07.2002  mailto: ruruhp@lycos.de
'
' Da es wenig Dokumentation und Material auerhalb der SDK fr ADOBE gibt,
' und das Adobe Forum alles andere als gut ist, wollte ich
' ein kleines Beispiel ber das Auslesen und Erkennen von
' PDF Dateien schreiben.
' Dieser Code liest die erste Seite eines Dokumentes und
' bergibt ihn an eine VB Funktion als String zur Auswertung des Inhaltes,
' um Sie, wie in diesem Beispiel z.B. einer Datenbanktabelle zu bergeben.

' Die PDF Datei Rechnung.PDF sowie die Vorlage in Word, Vorlage.DOC befinden
' sich im beiliegendem Zip Archiv


Option Explicit

Dim PDTextS As Acrobat.CAcroPDTextSelect
Dim Result As Long, PDDoc As Acrobat.CAcroPDDoc
Dim PDPage As Acrobat.CAcroPDPage
Dim PDHili As Acrobat.CAcroHiliteList
Dim B As Boolean
Dim PDFStream As String
Dim Filename As String

' Strings Falls Text von Anfang ausgelesen werden soll (bzw bis zum Ende)
Dim FromFirst As String
Dim ToLast As String

Private Type SQLField
    SQLName As String
    StartTxt As String
    EndTxt As String
End Type
Dim Indizes() As SQLField


Private Sub Form_Load()
' Text1 Multiline auf true setzen, sowie Scrollbars auf 3 (beide)

' Statische Datei
Filename = App.Path & "\Rechnung.pdf"

FromFirst = Chr(169) & Chr(170) & Chr(172)
ToLast = Chr(163) & Chr(165) & Chr(164)

' Indizes werden eingelesen
ReadSpecifications
End Sub


' Start Button

Private Sub Command1_Click()
Dim Str As String, NTL As Long, IString As String
Dim FieldValue As String, i As Integer
Dim SQLString As String, SQLRows As String

Label1.Visible = True

' Initialisierung mit Redim aus PDF SDK, drfte auch ohne funktionieren,
' so knnen aber mehrere Dokumente Instanziert werden
ReDim XY(1)

'Trotz Verweises mssen die meisten PDF Elemente ber CreateObject
' Eingebunden werden (New bei der Declaration der Variablen geht nicht!)
Set PDDoc = CreateObject("AcroExch.pdDoc")
Result = PDDoc.Open(Filename)

    If Not Result Then
        MsgBox "Can't open file: " & Filename
        Exit Sub
    End If

' Nehme die Erste Seite - Index 0
Set PDPage = PDDoc.AcquirePage(0)

' Erzeuge ein Highlight Objekt und weise ihm 2000 Elemente bei (keine Grenzprobleme)
Set PDHili = CreateObject("AcroExch.HiliteList")
B = PDHili.Add(0, 2000)

' Erzeuge eine Textauswahl aus dem gesamten Text
Set PDTextS = PDPage.CreatePageHilite(PDHili)

    ' Hole Anzahl der "Textblcke"
    NTL = PDTextS.GetNumText

    ' Gebe den Text der Textauswahl zurck
    For i = 0 To NTL - 1
        Str = Str & PDTextS.GetText(i)
    Next i
    
    
    Text1.Text = Str
    PDFStream = ""
    PDFStream = Str
    
    For i = 1 To 5
        FieldValue = GetIndexfromPDF(Indizes(i).StartTxt, Indizes(i).EndTxt)
        
        ' SQL FELDER
        If SQLRows = "" Then
            SQLRows = Indizes(i).SQLName
        Else
            SQLRows = SQLRows & "," & Indizes(i).SQLName
        End If
        
        ' Inhalt
        If IString = "" Then
            IString = FieldValue
        Else
            IString = IString & "," & FieldValue
        End If
        
    MsgBox Indizes(i).SQLName & "  =  " & FieldValue
    Next i
    SQLString = "Insert into TestTable (" & SQLRows & ") Values (" & IString & ")"
   
    MsgBox "Insert befehl fr die Datenbank:" & vbNewLine & SQLString


Result = PDDoc.Close

Set PDPage = Nothing
Set PDHili = Nothing
Set PDTextS = Nothing
Set PDDoc = Nothing
Label1.Visible = False
End Sub




' Einlesen der Daten
' zum Anpassen von Verschiedenen PDF Dateien knnen diese
' extern in eine INI Datei gespeichert werden und zur Laufzeit ausgelesen werden
Sub ReadSpecifications()
' in unserem Fall kennen wir die Anzahl der Felder
ReDim Preserve Indizes(1 To 5)

Indizes(1).SQLName = "Adresse"
Indizes(1).StartTxt = "Adresse:"
Indizes(1).EndTxt = "Tel:"

Indizes(2).SQLName = "Telefon"
Indizes(2).StartTxt = "Tel:"
Indizes(2).EndTxt = "Rechnungs Nr.:"

Indizes(3).SQLName = "Rechnungs_Nr"
Indizes(3).StartTxt = "Rechnungs Nr.:"
Indizes(3).EndTxt = "Betrag:"

Indizes(4).SQLName = "Betrag"
Indizes(4).StartTxt = "Betrag:"
Indizes(4).EndTxt = "Rechnung"

' Auch Texte mit Leerstellen knnen verwendet werden
Indizes(5).SQLName = "Text"
Indizes(5).StartTxt = "Rechnung ber"
Indizes(5).EndTxt = ToLast   ' Programminterne Konvention fr -'nimm den Rest'

End Sub

' Gebe den Inghalt eines Feldes zurck
Function GetIndexfromPDF(Start As String, EndS As String) As String
Dim Pos1 As Long, Pos2 As Long
Dim InitialText As String

On Error GoTo fehler

GetIndexfromPDF = ""
InitialText = PDFStream

    ' Cariage Return und LF werden eliminiert,
    ' macht natrlich keinen Sinn bei Text und NText SQL Felder
    InitialText = Replace(InitialText, Chr(13), "")
    InitialText = Replace(InitialText, Chr(10), " ")
    
' Variable von Anfang des Textes
If Start = FromFirst Then
    Pos1 = 1
Else
    Pos1 = InStr(InitialText, Start)    ' Position String1
End If

' Variable bis zum Ende des Textes
If EndS = ToLast Then
    Pos2 = Len(InitialText)
Else
    Pos2 = InStr(Pos1 + Len(Start), InitialText, EndS)  ' Position String2
End If

GetIndexfromPDF = Mid(InitialText, Pos1 + Len(Start), Pos2 - Pos1 - Len(Start) - 1)
Exit Function
fehler:
    MsgBox "Fehler in der Funktion " & GetIndexfromPDF & vbNewLine & _
            "Fehler Nr. " & Err.Number & vbNewLine & Err.Description, vbExclamation, "Fehler"

End Function
